package org.nakedobjects.nos.remote.command.marshal;

import org.nakedobjects.noa.adapter.Oid;
import org.nakedobjects.noa.adapter.Version;
import org.nakedobjects.nof.reflect.remote.data.ClientActionResultData;
import org.nakedobjects.nof.reflect.remote.data.CollectionData;
import org.nakedobjects.nof.reflect.remote.data.Data;
import org.nakedobjects.nof.reflect.remote.data.DummyClientResultData;
import org.nakedobjects.nof.reflect.remote.data.DummyCollectionData;
import org.nakedobjects.nof.reflect.remote.data.DummyNullValue;
import org.nakedobjects.nof.reflect.remote.data.DummyObjectData;
import org.nakedobjects.nof.reflect.remote.data.DummyReferenceData;
import org.nakedobjects.nof.reflect.remote.data.DummyResultData;
import org.nakedobjects.nof.reflect.remote.data.DummyValueData;
import org.nakedobjects.nof.reflect.remote.data.IdentityData;
import org.nakedobjects.nof.reflect.remote.data.NullData;
import org.nakedobjects.nof.reflect.remote.data.ObjectData;
import org.nakedobjects.nof.reflect.remote.data.ReferenceData;
import org.nakedobjects.nof.reflect.remote.data.ServerActionResultData;
import org.nakedobjects.nof.reflect.remote.data.ValueData;
import org.nakedobjects.nos.remote.command.DataFactory;


public class DummyObjectDataFactory implements DataFactory {
    public ObjectData createObjectData(final String type, final Oid oid, final boolean hasCompleteData, final Version version) {
        return new DummyObjectData(oid, type, hasCompleteData, version);
    }

    public ValueData createValueData(final String fullName, final String encodedValue) {
        return new DummyValueData(encodedValue, fullName);
    }

    public NullData createNullData(final String type) {
        return new DummyNullValue(type);
    }

    public IdentityData createIdentityData(final String type, final Oid oid, final Version version) {
        return new DummyReferenceData(oid, type, version);
    }

    public CollectionData createCollectionData(
            final String collectionType,
            final String elementType,
            final Oid oid,
            final ReferenceData[] elements,
            final boolean hasAllElements, final Version version) {
        return new DummyCollectionData(oid, collectionType, elementType, elements, version);
    }

    public ServerActionResultData createServerActionResultData(
            final Data result,
            final ObjectData[] updatesData,
            final ReferenceData[] disposed,
            final ObjectData persistedTarget,
            final ObjectData[] persistedParameters,
            final String[] messages,
            final String[] warnings) {
        return new DummyResultData(result, updatesData, disposed, persistedTarget, persistedParameters, messages, warnings);
    }

    public ClientActionResultData createClientActionResultData(
            final ReferenceData[] madePersistent,
            final Version[] changedVersion,
            final ObjectData[] updates) {
        return new DummyClientResultData(madePersistent, changedVersion, null);
    }
}
// Copyright (c) Naked Objects Group Ltd.
